with Interfaces.C.Strings; use Interfaces.C.Strings;
with Ada.Text_IO; use Ada.Text_IO;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Connections; use Connections;
with Sessions; use Sessions;
with Messages; use Messages;

procedure producer is
	con : Connection;
	ses : Session;
	msg : Message;
	queuename : Unbounded_String := 
	To_Unbounded_String("adaqueue");
	exchangename : Unbounded_String := 
	To_Unbounded_String("amq.direct");
	bindingkey : Unbounded_String := 
	To_Unbounded_String("adabind");
	emptyString : Unbounded_String := 
	To_Unbounded_String("");
begin
	Open(con, 
	To_Unbounded_String("127.0.0.1"), 
	5672, emptyString, emptyString);
	Start_Session(con, ses);
	Queue_Declare(ses, queuename, 
	emptyString, false, false, false);
	Set_Message(msg, 1, bindingkey,
	0,emptyString,emptyString,emptyString, 
	To_Unbounded_String("Hi! This is a message sent from Ada"));
	Bind(ses, queuename, exchangename, bindingkey);
	Message_Transfer(ses, exchangename, msg);
end producer;
